"""
    Uhrenanzeige.py, Info-Gk 12/13, WS, 2005-11-24
"""
#import Nummernanzeige
import time
import os
idle = 1

class Nummernanzeige:
    """Class Nummernanzeige
    """    
    
    # Operations
    def __init__(self, anzeigeLimit):
        """ function __init__
            Attributes:
            self.limit
            self.wert 
        """
        # Attributes:
        self.limit = anzeigeLimit - 1 # (int) 
        self.wert = 0

    
    def gibWert(self):
        """function gibWert
           gibt self.wert zurueck
        """
        return self.wert # 
    
    def gibAnzeigewert(self):
        """function gibAnzeigewert        
           gibt self.wert als Zeichenkette
           (String) zurueck
        """
        return str(self.wert)
    
    def setzeWert(self, ersatzwert):
        """function setzeWert
           setzt self.wert auf ersatzwert
        """
        self.wert = ersatzwert
    
    def erhoehen(self):
        """function erhoehen
           erhoeht self.wert, falls
           self.wert < self.limit
        """
        if (self.wert < self.limit):
            self.wert = self.wert + 1
        else:
            self.wert = 0
    



class Uhrenanzeige:
    """Class Uhrenanzeige
    """
    
    # Operations
    def __init__(self, std, min_,sec ):
        """function __init__
            # Attributes:
        """
        self.zeitanzeige = None  # (String) 
        self.stunden = Nummernanzeige(24)  # (Nummernanzeige) 
        self.minuten =  Nummernanzeige(60)
        self.sekunden = Nummernanzeige(60)
        self.stunden.setzeWert(std)
        self.minuten.setzeWert(min_)
        self.sekunden.setzeWert(sec)        
        
    
    def setzeUhrzeit(self, std, min_,sec ):
        """function setzeUhrzeit        
        std: int
        min_: int
        sec: int
        """
        #zeit = time.localtime()
        self.stunden.setzeWert(std)
        self.minuten.setzeWert(min_)
        self.sekunden.setzeWert(sec)
        
    
    def gibUhrzeit(self):
        """function gibUhrzeit        
        returns String
        """
        self.zeitanzeige = ''
        if self.stunden.gibWert() < 10:
            self.zeitanzeige = '0'
        self.zeitanzeige =  self.zeitanzeige + self.stunden.gibAnzeigewert()
        if self.minuten.gibWert() < 10:
            self.zeitanzeige = self.zeitanzeige + ':' + '0'
        else:
            self.zeitanzeige = self.zeitanzeige + ':'             
        self.zeitanzeige =  self.zeitanzeige + self.minuten.gibAnzeigewert()
        if self.sekunden.gibWert() < 10:
            self.zeitanzeige = self.zeitanzeige + ':' + '0'
        else:
            self.zeitanzeige = self.zeitanzeige + ':'                         
        self.zeitanzeige =  self.zeitanzeige + self.sekunden.gibAnzeigewert()
        print self.zeitanzeige

        
    def anzeigeAktualisieren(self):
        """function anzeigeAktualisieren
        """
        self.taktsignalGeben()
        self.gibUhrzeit()
            
    def taktsignalGeben(self):
        """function taktsignalGeben
        """
        self.sekunden.erhoehen()
        if self.sekunden.gibWert() == 0:
            self.minuten.erhoehen()
        if self.minuten.gibWert() == 0:
            self.stunden.erhoehen()            
        time.sleep(1)
        if not idle:
            os.system('cls')  # by Steffen Foersch!      

    def go(self):
        """function go
        """
        self.gibUhrzeit()
        while 1:
            self.anzeigeAktualisieren()


if  __name__ == '__main__':
    idle = 1    # idle-Flag
    zeit = time.localtime() # aktuelle Zeit holen
    Uhr = Uhrenanzeige(zeit[3],zeit[4],zeit[5])
    Uhr.go()

